#!/usr/bin/perl
# (c) 2002 by Gerfried Fuchs <alfie@channel.debian.de>

use Irssi qw(command_bind active_win);
use strict;
use vars qw($VERSION %IRSSI);

$VERSION = '1.1';

%IRSSI = (
  'authors'     => 'Gerfried Fuchs (irssi implementation),Jan-Pieter Cornet (true script)',
  'contact'     => 'alfie@channel.debian.de,johnpc@xs4all.nl',
  'name'        => 'Kenny Filter',
  'description' => '/kenny and /dekenny filter based on Jan-Pieter Cornets signature version',
  'url'         => 'http://alfie.ist.org/projects/irssi/scripts/kenny.pl',
  'license'     => 'BSD',
  'changed'     => '2002-03-27'
);
# This script offers you /kenny and /dekenny with both do the kenny-filter
# magic on the argument you give it.  Despite it's name *both* do kenny/dekenny
# the argument; the difference is that /kenny writes it to the channel but
# /dekenny only to your screen.

# TODO - a function that detects kennyfied text and decodes it autmagically so
# you don't have to copy&paste the text to /dekenny

sub cmd_kenny {
   ($_)=@_;my($p,$f);$p=3-2*/[^\W\dmpf_]/i;s.[a-z]{$p}.vec($f=join('',$p
   -1?chr(sub{$_[0]*9+$_[1]*3+$_[2] }->(map {/p|f/i+/f/i}split//,$&)+97)
   :('m','p','f')[map{((ord$&)%32-1)/$_%3}(9, 3,1)]),5,1)='`'lt$&;$f.eig
   ;active_win->command("say $_");# Based on Jan-Pieter Cornet's version
}

sub cmd_dekenny {
   ($_)=@_;my($p,$f);$p=3-2*/[^\W\dmpf_]/i;s.[a-z]{$p}.vec($f=join('',$p
   -1?chr(sub{$_[0]*9+$_[1]*3+$_[2] }->(map {/p|f/i+/f/i}split//,$&)+97)
   :('m','p','f')[map{((ord$&)%32-1)/$_%3}(9, 3,1)]),5,1)='`'lt$&;$f.eig
   ;active_win->print($_);        # Based on Jan-Pieter Cornet's version
}

command_bind('kenny', 'cmd_kenny');
command_bind('dekenny', 'cmd_dekenny');
